Selling Pieces of Wood: You are given two integers m
and n
that represent the height and width of a rectangular piece of wood. You are also given a 2D integer array prices
, where prices[i] = [hi, wi, pricei]
indicates you can sell a rectangular piece of wood of height hi
and width wi
for pricei
dollars.
To cut a piece of wood, you must make a vertical or horizontal cut across the entire height or width of the piece to split it into two smaller pieces. After cutting a piece of wood into some number of smaller pieces, you can sell pieces according to prices
. You may sell multiple pieces of the same shape, and you do not have to sell all the shapes. The grain of the wood makes a difference, so you cannot rotate a piece to swap its height and width.
Return the maximum money you can earn after cutting an m x n
piece of wood.
Note that you can cut the piece of wood as many times as you want.
Selling Pieces of Wood LeetCode
Example 1:
Input: m = 3, n = 5, prices = [[1,4,2],[2,2,7],[2,1,3]] Output: 19 Explanation: The diagram above shows a possible scenario. It consists of: - 2 pieces of wood shaped 2 x 2, selling for a price of 2 * 7 = 14. - 1 piece of wood shaped 2 x 1, selling for a price of 1 * 3 = 3. - 1 piece of wood shaped 1 x 4, selling for a price of 1 * 2 = 2. This obtains a total of 14 + 3 + 2 = 19 money earned. It can be shown that 19 is the maximum amount of money that can be earned.
Example 2:
Input: m = 4, n = 6, prices = [[3,2,10],[1,4,2],[4,1,3]] Output: 32 Explanation: The diagram above shows a possible scenario. It consists of: - 3 pieces of wood shaped 3 x 2, selling for a price of 3 * 10 = 30. - 1 piece of wood shaped 1 x 4, selling for a price of 1 * 2 = 2. This obtains a total of 30 + 2 = 32 money earned. It can be shown that 32 is the maximum amount of money that can be earned. Notice that we cannot rotate the 1 x 4 piece of wood to obtain a 4 x 1 piece of wood.
Constraints:
1 <= m, n <= 200
1 <= prices.length <= 2 * 104
prices[i].length == 3
1 <= hi <= m
1 <= wi <= n
1 <= pricei <= 106
- All the shapes of wood
(hi, wi)
are pairwise distinct.
Solution
Explanation
For a piece of w * h
,
we can make a vertical cut to split it into a * h
and (w - a) * h
So we can update dp[w][h] = max(dp[w][h], dp[a][h] + dp[w - a][h])
.
we can make a horizontal cut to split it into w * a
and w * (h - a)
So we can update dp[w][h] = max(dp[w][h], dp[w][a] + dp[w][h - a])
.
Complexity
Time O(mmn + mnn)
Space O(mn)
public long sellingWood(int m, int n, int[][] prices) {
long[][] dp = new long[m + 1][n + 1];
for (int[] p : prices)
dp[p[0]][p[1]] = p[2];
for (int w = 1; w <= m; ++w) {
for (int h = 1; h <= n; ++h) {
for (int a = 1; a <= w / 2; ++a)
dp[w][h] = Math.max(dp[w][h], dp[a][h] + dp[w - a][h]);
for (int a = 1; a <= h / 2; ++a)
dp[w][h] = Math.max(dp[w][h], dp[w][a] + dp[w][h - a]);
}
}
return dp[m][n];
}
long long sellingWood(int m, int n, vector<vector<int>>& prices) {
long long dp[201][201] = {};
for (auto& p: prices)
dp[p[0]][p[1]] = p[2];
for (int w = 1; w <= m; ++w) {
for (int h = 1; h <= n; ++h) {
for (int a = 1; a <= w / 2; ++a)
dp[w][h] = max(dp[w][h], dp[a][h] + dp[w - a][h]);
for (int a = 1; a <= h / 2; ++a)
dp[w][h] = max(dp[w][h], dp[w][a] + dp[w][h - a]);
}
}
return dp[m][n];
}
def sellingWood(self, m, n, prices):
dp = [[0] * (n + 1) for i in range(m+1)]
for w, h, p in prices:
dp[w][h] = p
for w in range(1, m + 1):
for h in range(1, n + 1):
for a in range(1, w // 2 + 1):
dp[w][h] = max(dp[w][h], dp[a][h] + dp[w - a][h])
for a in range(1, h // 2 + 1):
dp[w][h] = max(dp[w][h], dp[w][a] + dp[w][h - a])
return dp[m][n]
Happy Learning – If you require any further information, feel free to contact me.